import QtQuick 1.1
import com.nokia.meego 1.0
import QtWebKit 1.0

Page {
    id: page1
    property variant pictures: []
    property int currentNdx: 0
    property int attempt: 0
    property int currentImageNdx: 1

    onStatusChanged: {
        if (status === PageStatus.Active) {
            page1.downloadFile();

        }
    }

    Rectangle {
        anchors.fill: parent
        color: "black"
        id: rect

        MouseArea {
                id: mArea
                 anchors.fill: parent

                 Connections {
                     target: myObject
                     onDownloaded: {                         
                         debugText.text = myObject.downloadedString();

                         page1.pictures = page1.getPictures(myObject.downloadedString())

                         if (page1.pictures != null && page1.pictures !== [] && page1.pictures.length > 0)
                            page1.setNextPicture(0)
                     }
                 }
                 onPressAndHold : {
                     savedText.blink()
                     myObject.save(getNotCurrentImage(), "/home/user/MyDocs/Pictures/oboobs" + new Date().getTime() + ".jpg");
                 }

                 onClicked: {
                     page1.downloadFile();
                 }

             }

        Text {
            id: debugText
            text: 'hello'
            color: "White"
            visible: false
            textFormat: Text.PlainText
            anchors.top: rect.top
            anchors.horizontalCenter: page1.horizontalCenter
            font.family: "Helvetica"
            font.pixelSize: 14
        }

        Text {
            id: errorText
            text: "Error: Could not retrieve boobs!"
            color: "FireBrick"
            anchors.verticalCenter: parent.verticalCenter
            anchors.horizontalCenter: parent.horizontalCenter
            font.family: "Helvetica"
            font.pixelSize: 30
            visible: getCurrentImage().status === Image.Error
        }




        Image {
            id: img1
            smooth: true
            anchors.fill: parent
            transformOrigin: Item.Center
            visible: true
            opacity: 0.0
            fillMode: Image.PreserveAspectFit
            onStatusChanged: {
                if (status === Image.Ready) page1.showNewImageAnimation();
            }

            function hideAnimation() {
                console.log("hideAnimationImg1.start();")
                hideAnimationImg1.start();
            }

            function showAnimation() {
                console.log("showAnimationImg1.start();")
                showAnimationImg1.start();
            }

            PropertyAnimation {id: hideAnimationImg1; target: img1; properties: "opacity"; to: 0; duration: 300}
            PropertyAnimation {id: showAnimationImg1; target: img1; properties: "opacity"; to: 1; duration: 300}
        }

        Image {
            id: img2
            smooth: true
            anchors.fill: parent
            transformOrigin: Item.Center
            visible: true
            opacity: 0.0
            fillMode: Image.PreserveAspectFit
            onStatusChanged: {
                if (status === Image.Ready) showNewImageAnimation();
            }

            function hideAnimation() {
                console.log("hideAnimationImg2.start();")
                hideAnimationImg2.start();
            }

            function showAnimation() {
                console.log("showAnimationImg2.start();")
                showAnimationImg2.start();
            }

            PropertyAnimation {id: hideAnimationImg2; target: img2; properties: "opacity"; to: 0; duration: 300}
            PropertyAnimation {id: showAnimationImg2; target: img2; properties: "opacity"; to: 1; duration: 300}
        }

        Text {
            id: savedText
            text: "Saved to gallery."
            font.bold: true
            color: "BlanchedAlmond"
            opacity: 0.0
            anchors.top: parent.top
            anchors.horizontalCenter: parent.horizontalCenter
            font.family: "Helvetica"
            font.pixelSize: 25

            PropertyAnimation {id: hideAnimation; target: savedText; properties: "opacity"; to: 0; duration: 1000}

            function blink()
            {
                savedText.opacity = 1.0
                hideAnimation.start()
            }
        }

    }

    function showNewImageAnimation() {
        console.log("showNewImageAnimation");
        getNotCurrentImage().hideAnimation()
        getCurrentImage().showAnimation()
        currentImageNdx = (currentImageNdx == 1) ? 2 : 1;
    }

    function downloadFile() {
        if (page1.pictures.length == 0)
        {
            myObject.downloadFile("http://oboobs.ru/a" + (page1.attempt++ % 2 === 0 ? '/' : ''))
        }
        else
            page1.setNextPicture()
    }

    function setNextPicture()
    {
        console.log("setNextPicture");

        if (page1.currentNdx >= page1.pictures.length - 1) {
            page1.currentNdx = 0
            page1.pictures = []
            myObject.downloadFile("http://oboobs.ru/a" + (page1.attempt++ % 2 === 0 ? '/' : ''))
        }
        else
        {
            page1.currentNdx ++;
            getCurrentImage().source = "" + page1.pictures[page1.currentNdx]
        }
    }

    function getCurrentImage() {
        return (currentImageNdx === 1) ? img1 : img2;
    }

    function getNotCurrentImage() {
        return (currentImageNdx === 2) ? img1 : img2;
    }

    function getPictures(html)
    {
        var exp = /http:\/\/media.oboobs.ru\/noise_preview\/\d*.jpg/g
        var res = exp.exec(html)

        var pictures = []

        while (res != null) {
            pictures.push(res)
            res = exp.exec(html)
        }

        return pictures
    }

}
